﻿using Kivii.Seeyon.Entities;
using Kivii.Web;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Seeyon.Transforms
{
    //[RequiresAnyRole(SystemRoles.Everyone)]
    //[Api(Description = "提交OA申请表单")]
    //public class ApplyRequest2 : RestfulExecution<Apply>
    //{
    //    public string EntityType { get; set; }
    //    public object Form { get; set; }

    //    public override object OnExecution(IRequest req, IResponse res)
    //    {
    //        EntityType.ThrowIfNull("请传入业务实体EntityType");
    //        var type = Kivii.Text.AssemblyUtils.FindType(EntityType);

    //        var instance = Activator.CreateInstance(type) as IEntityIsSeeyonApply;
    //        if (instance == null) return null;
    //        var results = instance.OnSubmitApplyForm(Form);
    //        return results;
    //    }
    //}

    [RequiresAnyRole(SystemRoles.Everyone)]
    [Api(Description = "提交OA申请表单")]
    public class ApplyRequest : RestfulExecutionGeneric<Apply>
    {
        public string FormType { get; set; }

        public Guid Kvid { get; set; }

        public override object OnExecutionGeneric<G>(IRequest req, IResponse res)
        {
            FormType.ThrowIfNull("请传入业务实体FormType");
            var type = Kivii.Text.AssemblyUtils.FindType(FormType);

            var instance = Activator.CreateInstance(type) as IEntityIsSeeyonApply;
            if (instance == null) return null;
            var results = instance.OnSubmitApplyForm<G>(Kvid);
            return results;
        }
    }

    [Api(Description = "OA结果调用")]
    public class ApplyResult : RestfulExecution<Apply>
    {
        public string FormType { get; set; }

        public Guid Kvid { get; set; }

        public object Result { get; set; }

        public string Message { get; set; }

        public override object OnExecution(IRequest req, IResponse res)
        {
            FormType.ThrowIfNull("请传入业务实体FormType");
            var type = Kivii.Text.AssemblyUtils.FindType(FormType);

            var instance = Activator.CreateInstance(type) as IEntityIsSeeyonApply;
            if (instance == null) return null;
            var results = instance.OnGetApplyResult(Kvid, Result, Message);
            return results;
        }
    }
}
